Subject: Re: New diff test failures on s390x architecture (was: [ANNOUNCE] Git v2.22.0-rc1)

From: Todd Zullinger <[email-masked]>
Date: Thu, 23 May 2019 15:14:30 -0400

I wrote:
> While running the 2.22.0-rc1 tests on Fedora, I hit a few
> new test failures since 2.21.0 -- but only on the s390x
> architecture.
> 
> I haven't had time to dig into these the past few days, so I
> thought I would send what I do have in case the problem is
> obvious to someone else.  I think all of the failing tests
> are due to `git diff` commands.
[...]
> I don't have direct access to these s390x builders.  I may
> be able to arrange shell access (or even reproduce this with
> qemu's s390x emulation).

I poked around a little with a qemu s390x instance and see
the same failures.

One simple failure in t4015 is with:

    git diff -w >out &&
    test_must_be_empty out

Using git-2.21.0 this succeeds, while git-2.22.0-rc1 fails
and produces:

    diff --git a/x b/x
    index d99af23..22d9f73 100644
    --- a/x
    +++ b/x
    @@ -1,6 +1,6 @@
    -whitespace at beginning
    -whitespace change
    -whitespace in the middle
    -whitespace at end
    + 	whitespace at beginning
    +whitespace 	 change
    +white space in the middle
    +whitespace at end  
     unchanged line
    -CR at end
    +CR at end

I am guessing it's no coincidence that this only fails on
s390x and it is the only big endian architecture in the
fedora build system.

-- 
Todd